<?php
// -----------------------------------------------------------
//   SiteBuilder (c) 2004-2005, SWsoft
//
//   since: 10 May 2005
// version: $Id: filesStorage.php,v 1.7 2005/12/19 03:45:01 epalchukovsky Exp $
//  author: Evgene V. Palchukovsky
// -----------------------------------------------------------

if(!function_exists('dio_open')):

	define('F_SETLKW',1);
	define('O_RDWR',2);
	define('O_TRUNC',4);
	define('O_CREAT',8);
	define('O_RDONLY',16);
	define('O_WRONLY',32);

	function dio_open($f,$m,$p)
	{
		return fopen($f,$m&O_WRONLY?'w':($m&O_RDWR?'r+':'r'));
	}
	
	function dio_close($h)
	{
		fclose($h);
	}

	function dio_fcntl($h,$cmd,$parmZZZ)
	{
		flock($h,2);
	}
	
	function dio_read($h)
	{
		return fread($h,1024);
	}
	
	function dio_seek($h,$o,$m)
	{
		return fseek($h,$o,$m);
	}
	
	function dio_truncate($h,$l)
	{
		return ftruncate($h,$l);
	}
	
	function dio_write($h,$d)
	{
		return fwrite($h,$d);
	}
	
endif;

define('STORAGE_MODS','../data/');
define('STORAGE_MOD',STORAGE_MODS.$GLOBALS['_counterId'].'/');

class Storage {
	
	function GetUser() {
		$this->m_data['new'] = !isset($_COOKIE[$GLOBALS['_counterId']]) || file_exists('prew');
		return true;
	}
	
	function CreateStroagePlace() {
		if (!file_exists(STORAGE_MODS)) {
			mkdir(STORAGE_MODS);
			chmod(STORAGE_MODS, 0777);
		}
		mkdir(STORAGE_MOD);
		chmod(STORAGE_MOD, 0777);
	}
	
	function CreateDefs($data = '0', $time = '0') {
		$defFile = dio_open(STORAGE_MOD.'data',O_WRONLY|O_CREAT|O_TRUNC,0666);
		if ($defFile) {
			dio_fcntl($defFile, F_SETLKW, array('read lock', 'write lock'));
			dio_write($defFile, $data);
			dio_close($defFile);
		}
		$timeFile = dio_open(STORAGE_MOD.'data_time', O_WRONLY|O_CREAT|O_TRUNC, 0666);
		if ($timeFile) {
			dio_fcntl($timeFile, F_SETLKW, array('read lock', 'write lock'));
			dio_write($timeFile, $time);
			dio_close($timeFile);
		}
	}
	
	function UpdateDefs() {
		$timeNew = 0;
		if (file_exists(STORAGE_MOD.'data_time')) {
			$timeFileNew = dio_open('new_data_time', O_RDONLY, 0666);
			$timeFile = dio_open(STORAGE_MOD.'data_time', O_RDONLY, 0666);
			if ($timeFileNew&&$timeFile) {
				$timeNew = dio_read($timeFileNew);
				dio_close($timeFileNew);
				$time = dio_read($timeFile);
				dio_close($timeFile);
				if ($time==$timeNew) {
					return;
				}
			}
		}
		$data = 0;
		$defFile = dio_open('new_data', O_RDONLY, 0666);
		if ($defFile) {
			$data = trim(dio_read($defFile));
			dio_close($defFile);
		}
		$this->CreateDefs($data, $timeNew);
	}
	
	
	function GetHandle() {
		if (!file_exists(STORAGE_MOD)) {
			$this->CreateStroagePlace();
		}
		if (file_exists('new_data')&&file_exists('new_data_time')) {
			$this->UpdateDefs();
		}
		if (!file_exists(STORAGE_MOD.'data')) {
			$this->CreateDefs();
		}
		if (file_exists('data') && !file_exists(STORAGE_MOD.'data_old')) {
			$this->_migrate();
		}
		$this->m_storageHandle['handle'] = dio_open(STORAGE_MOD.'data',O_RDWR,0666);
		if ($this->m_storageHandle['handle']) {
			dio_fcntl($this->m_storageHandle['handle'], F_SETLKW, array('read lock', 'write lock'));
			return true;
		} else {
			$this->CloseHandle();
			return false;
		}
	}
	
	function CloseHandle() {
		if ($this->m_storageHandle) {
			dio_close($this->m_storageHandle['handle']);
		}
		$this->m_storageHandle = NULL;
	}

	function Cleaning() {
		/*...*/
	}
	
	function Count() {
		$this->m_data['count'] = trim(dio_read($this->m_storageHandle['handle']));
		if ($this->m_data['new']) {
			dio_seek($this->m_storageHandle['handle'], 0, SEEK_SET);
			dio_truncate($this->m_storageHandle['handle'], 0);
			dio_write($this->m_storageHandle['handle'], ++$this->m_data['count']);
			$t = time();
			setcookie($GLOBALS['_counterId'], $t, $t+86400);
		}
	}
	
	function _migrate() {
		copy('data', STORAGE_MOD.'data');
		copy('data', STORAGE_MOD.'data_old');
	}

}

?>